package Output;

use Exporter ();
@ISA=qw(Exporter);
@EXPORT=qw(aTtx);

use strict;

my $pkg="Output";

use lib ("/home/web-maccess/www/lib");
use My;
use MyXML;
use Cs;
use Format;
use Link;
use CGI;
use Info;
use Outputsend;


#=== definice globalnich promennych baliku
my $outputstyle={};
my $prvniradek;
my @summary_color=("red","blue","green");


#=== funkce nastavujici globalni promenou baliku $outputstyle, ktera urcuje jak bude vystup vypadat
sub set_outputstyle {
   my ($pkg_p, $outputstyleprac,$tableI)=@_;
   # definice globalni promenne $outputstyle z prevzate $outputstyleprac
   $outputstyle=$outputstyleprac;
   # dodefinovani globalni promenne $outputstyle dle zaznamu ve znacce table
   if(my $dropemptyline=$tableI->findvalue('@dropemptyline')) {
      $$outputstyle{dropemptyline}=$dropemptyline;
   }
   # definice globalni promenne $prvniradek
   $prvniradek=$$outputstyle{prvniradek}-(int($$outputstyle{prvniradek}/$$outputstyle{radku})*$$outputstyle{radku});
}

#== hlavni funkce generujici vystup ==#
sub output {
   my ($pkg_p, $htmlO,$tableI,$outputstyleprac,$typ)=@_;
   my $lineno;
   $pkg->set_outputstyle($outputstyleprac,$tableI);
   if($typ eq "list") {
      $pkg->append_mainlist($htmlO,$tableI);
   }
   else {
      $lineno=$pkg->append_maintable($htmlO,$tableI);
   }
   return $lineno;
}



#********** TABLE *********************************
#== hlavni funkce generujici vystupy typu table ==#
sub append_maintable {
   my ($pkg_p, $tableO,$tableI)=@_;
   my $lineno;
   # nacerpani nekterych udaju o sloupcich do hashe $colsinfo (zarovnani, viditelnost a podobne)
   my $colsinfo=$pkg->colsinfo($tableI);
   if($$outputstyle{typvystupu} eq "txtfixed") {
      # u txtfixed je treba xml dokument napred projit a zjistit nektere udaje a az po te renderovat - dopln tyto udaje do $colsinfo
      $colsinfo=$pkg->collength($tableI,$colsinfo);
      # renderovani
      $lineno=$pkg->append_table($tableO,$tableI,$colsinfo);
   }
   elsif($$outputstyle{typvystupu} eq "txt") {
      # u txt neni treba zjistovat maximalni delku sloupcu, ale tato funkce provadi i formatovani hodntot pro txt vystupy a proto ji poustim
      $colsinfo=$pkg->collength($tableI,$colsinfo);
      # renderovani
      $lineno=$pkg->append_table($tableO,$tableI,$colsinfo);
   }
   else {
      # renderovani
      $lineno=$pkg->append_table($tableO,$tableI,$colsinfo);
   }
   return $lineno;
}

#== tabulka ==#
sub append_table {
   my ($pkg_p, $tableO,$tableI,$colsinfo)=@_;
   my $bordersize;
   if($$outputstyle{typzar} eq "printerux" or $$outputstyle{typzar} eq "printerwin") {
      $bordersize="1";
   }
   else {
      $bordersize="0";
   }
   my $tableOO=aTt($tableO,"table",{cellspacing=>"0px",cellpadding=>"3px",border=>$bordersize,class=>"o1"});
   # definice o zarovnani sloupcu a hlavicka tabulky
   my $colgroupO=aTt($tableOO,"colgroup");
   my $colnum=0;
   foreach my $colI ($tableI->findnodes('cols/col')) {
      aTt($colgroupO,"col",{
         align=>$pkg->colalign($$colsinfo{type}[$colnum]),
         class=>$pkg->colclass($colI->findvalue('@chosen')),
      });
      ++$colnum;
   }
   # hlavicka a telo tabulky
   my $theadO=aTt($tableOO,"thead");
   my $lineno=$pkg->append_head($theadO,$tableI,$colsinfo,$prvniradek,undef);
   my $tbodyO=aTt($tableOO,"tbody");
   my ($rowsI)=$tableI->findnodes('rows');
   $lineno=$pkg->append_rows($tbodyO,$tableI,$rowsI,$colsinfo,$lineno);
   return $lineno;
}


#== hlavicka tabulky ==#
sub append_head {
   my ($pkg_p, $tableOO,$tableI,$colsinfo,$lineno,$zalomeni)=@_; # pokud je $zalomeni undef tak jde o tisk uplne prvni hlavicky
   my $append_head;
   # ma se tisknout hlavicka? a kdyz ano, tak pokud je to nutne odradkuj, aby zacla na nove strance (pokud to neni prvni hlavicka)
   if($lineno+$zalomeni>$$outputstyle{radku}) {
      $tableOO=aTf($tableOO,undef,{}, ("\n" x ($$outputstyle{radku}-$lineno+$$outputstyle{dokraj})) ); # . "\x{0d}" );
      $lineno=$$colsinfo{linesplitcount}+3;
      $append_head=1;
   }
   elsif(!defined($zalomeni)) {
      if($lineno+$$colsinfo{linesplitcount}+3>$$outputstyle{radku}) { # pro pripad, ze uz by se ani prvni hlavicka nevlezla na obrazovku, jelikoz je pred ni text
         $tableOO=aTf($tableOO,undef,{}, ("\n" x ($$outputstyle{radku}-$lineno)) );
         $lineno=0;
      }
      $lineno+=$$colsinfo{linesplitcount}+3;
      $append_head=1;
   }
   # kdyz se ma tak tiskni hlavicku
   if($append_head) {
      my $trO=aTt($tableOO,"tr");
      my $trO2=aTf($trO,"font",{color=>"green"});
      aTf($trO2,undef,{}, ("-" x $$outputstyle{sloupcu}) . "\n");
      my $colnum=0;
      foreach my $colI ($tableI->findnodes('cols/col')) {
         if(!$$colsinfo{hidden}[$colnum]) {
            my $thO=aTt($trO2,"th",{class=>"o1"});
            $lineno-=$pkg->append_col($thO,$colI,$colsinfo,$colnum);
         }
         ++$colnum;
      }
      aTx($trO2,undef,{},"\n");
      aTf($trO2,undef,{}, ("-" x $$outputstyle{sloupcu}));
      aTf($trO,undef,{}, "\n");
   }
   return $lineno;
}


#== funkce renderujici znacku rows ==#
sub append_rows {
   my ($pkg_p, $tableOO,$tableI,$rowsI,$colsinfo,$lineno)=@_;
   foreach my $node ($rowsI->childNodes) {
      my $nodename=$node->cloneNode(0)->nodeName;
      if($nodename eq "row") {
         $lineno=$pkg->append_head($tableOO,$tableI,$colsinfo,$lineno,$$colsinfo{linesplitcount}+1);
         my $linenominus=$pkg->append_row($tableOO,$node,$colsinfo);
         $lineno+=$$colsinfo{linesplitcount}+1-$linenominus;
      }
      elsif($nodename eq "rows_heading" and !$node->findvalue('@hidden')) {
         $lineno=$pkg->append_head($tableOO,$tableI,$colsinfo,$lineno,1);
         my $linenopom=$pkg->append_rows_heading($tableOO,$node,$colsinfo);
         $lineno+=$linenopom;
      }
      elsif($nodename eq "rows_summary") {
         $lineno=$pkg->append_head($tableOO,$tableI,$colsinfo,$lineno,$$colsinfo{linesplitcount}+2);
         my $linenopom=$pkg->append_rows_summary($tableOO,$node,$colsinfo);
         $lineno+=$$colsinfo{linesplitcount}+$linenopom;
      }
      elsif($nodename eq "rows") {
         $lineno=$pkg->append_rows($tableOO,$tableI,$node,$colsinfo,$lineno);
      }
   }
   return $lineno;
}


#== funkce renderujici znacku rows_heading ==#
sub append_rows_heading {
   my ($pkg_p, $tableOO,$rows_heading,$colsinfo)=@_;
   my $depth_now=$rows_heading->findvalue("count(ancestor::node())-3");
   ## ZMENA 2002-09-05 - zavedeni vkladani class u znacky tr
   my $trO=aTt($tableOO,"tr",{class=>$pkg->colclass($rows_heading->findvalue('@chosen'))});
   my $tdO=aTt($trO,"td",{colspan=>$$colsinfo{colcount},class=>"heading".$depth_now});
   my $bO=$tdO->aT("b");
   my ($value,$xhtml)=$pkg->return_value($rows_heading,1); # !!! cislo 1 zajistuje, ze bude vzdy (i u txtfixed) vlozen pripadny xhtml kod v rows_heading - predpokladam, ze takovy kod nema vliv na lamani v radku (neobsahuje znacky <p><div><br>...)
   $pkg->append_value($bO,$rows_heading,$value,$xhtml);
   aTx($trO,undef,{},"\n");
   return 1;
}


#== funkce renderujici znacku rows_summary ==#
sub append_rows_summary {
   my ($pkg_p, $tableOO,$rows_summary,$colsinfo)=@_;
   my $linenopom;
   my $depth_now=$rows_summary->findvalue("count(ancestor::node())-3");
   ## ZMENA 2002-09-05 - zavedeni vkladani class u znacky tr
   my $trO=aTt($tableOO,"tr",{class=>$pkg->colclass($rows_summary->findvalue('@chosen'))});
   my $colnum=0;
   foreach my $colI ($rows_summary->findnodes('col')) {
      if(!$$colsinfo{hidden}[$colnum]) {
         my $tdO=aTt($trO,"td",{class=>"summary".$depth_now});
         my $bO=$tdO->aT("b");
         my $spanO=aTtx($bO,"span",{style=>"color: ".$summary_color[$depth_now].";"});
         $linenopom-=$pkg->append_col($spanO,$colI,$colsinfo,$colnum,1);
      }
      ++$colnum;
   }
   aTx($trO,undef,{},"\n");
   my $nodeSibling=$rows_summary->nextSibling;
   if(!defined($nodeSibling)) { # dalsi zalomeni jen kdyz jiz nenasleduje zadny sourozenec
      aTx($trO,undef,{},"\n");
      $linenopom+=2;
   }
   else {
      $linenopom+=1;
   }
   return $linenopom;
}


#== funkce renderujici znacku row ==#
sub append_row {
   my ($pkg_p, $tableOO,$row,$colsinfo)=@_;
   my $linenominus;
   ## ZMENA 2002-09-05 - zavedeni vkladani class u znacky tr
   my $trO=aTt($tableOO,"tr",{class=>$pkg->colclass($row->findvalue('@chosen'))});
   my $colnum=0;
   foreach my $colI ($row->findnodes('col')) {
      if(!$$colsinfo{hidden}[$colnum]) {
         my $tdO=aTt($trO,"td",{class=>"o1"});
         $linenominus+=$pkg->append_col($tdO,$colI,$colsinfo,$colnum,1);
      }
      ++$colnum;
   }
   $linenominus+=$pkg->dropemptyline($trO);
   aTx($trO,undef,{},"\n");
   return $linenominus;
}


#== funkce tisknouci hodnotu ci cely xhtml strom zadaneho node ==#
sub append_col {
   my ($pkg_p, $nodeO,$nodeI,$colsinfo,$colnum,$isvalue)=@_;
   my $linenominus;
   my ($value,$xhtml);
   # ziskavani hodnoty u vystupu table
   if($$outputstyle{typvystupu} eq "table") {
      ($value,$xhtml)=$pkg->return_value($nodeI);
      my $collength=length($value);
      # pripadne naformatovani hodnoty - jen u pripadu tisku hodnot (proto sem do funkce taham promenou $isvalue)
      if($isvalue and length($$colsinfo{formatfce}[$colnum]) and $collength) {
         my $format_fce=$$colsinfo{formatfce}[$colnum];
         $value=Format->$format_fce($value,@{$$colsinfo{formatfce_param}[$colnum]});
         # predpokladam, ze vsechny mezery se maji u formatovanych hodnot nahradit tvdyma
         ## ZATIM TO NEDELAM
         # Radek nize pozdeji odpoznamkovat ci jinak vyresit
         #$value=~s/ /\x{a0}/g;  # mozna to bude pozdeji treba zmenit (jde o tvrdou mezeru &#160; viz: http://www.perldoc.com/perl5.6/pod/perlunicode.html)
         # - konec
      }
      else {
         if(!$collength and $isvalue) {
            $value="\x{a0}"; # mozna to bude pozdeji treba zmenit (jde o tvrdou mezeru &#160; viz: http://www.perldoc.com/perl5.6/pod/perlunicode.html)
         }
      }
      # vlozeni hodnoty
      $pkg->append_value($nodeO,$nodeI,$value,$xhtml);
   }
   # u txtfixed vystupu jsem hodnoty jiz naformatoval a ulozil do atributu formatval
   elsif($$outputstyle{typvystupu} eq "txtfixed") {
      ($value,$xhtml)=$pkg->return_value($nodeI,1);
      if(!defined($xhtml)) {
         $value=$nodeI->findvalue('@formatval');
      }
      # pridani sepratoru mezi sloupci
      $nodeO->aT(undef,{},$$colsinfo{colsepar}[$colnum]);
      # dorovnani hodnoty ve sloupci na jeho pevnou sirku
#      $value=sprintf(
#                "%".
#                   $$colsinfo{alignzn}[$colnum].
#                   $$colsinfo{collength}[$colnum].".".$$colsinfo{collength}[$colnum].
#                   "s",
#                $nodeI->findvalue('@formatval')
#             );
      # doplneni mezer vlevo
      if($$colsinfo{alignzn}[$colnum] ne "-") {
         $nodeO->aT(undef,{}, " " x ($$colsinfo{collength}[$colnum]-length($nodeI->findvalue('@formatval'))) );
         # vlozeni hodnoty
         $pkg->append_value($nodeO,$nodeI,$value,$xhtml);
      }
      # doplneni mezer vpravo
      else {
         # vlozeni hodnoty
         $pkg->append_value($nodeO,$nodeI,$value,$xhtml);
         $nodeO->aT(undef,{}, " " x ($$colsinfo{collength}[$colnum]-length($nodeI->findvalue('@formatval'))) );
      }
      # u txtfixed se lame radek na mistech jiz drive zjistenych a po te se doplnuji mezery, aby nasledujici cast zlomeneho radku byla posunuta uplne doprava
      if(defined($$colsinfo{linesplitspace}[$colnum+1])) {
         $linenominus+=$pkg->dropemptyline($nodeO);
         $nodeO->aT(undef,{},"\n");
         $nodeO->aT(undef,{}, (" " x $$colsinfo{linesplitspace}[$colnum+1]) );
      }
   }
   # u txt vystupu jsem hodnoty jiz naformatoval a ulozil do atributu formatval
   elsif($$outputstyle{typvystupu} eq "txt") {
      $value=$nodeI->findvalue('@formatval');
      # vlozeni hodnoty
      $pkg->append_value($nodeO,$nodeI,$value,$xhtml);
      # u txt je treba jeste pridat tabulator
      $nodeO->aT(undef,{},"\t");
   }
   return $linenominus;
}



#********** LIST *********************************
#== hlavni funkce generujici vystupy typu list ==#
sub append_mainlist {
   my ($pkg_p, $tableO,$tableI)=@_;
   # nacerpani nekterych udaju o sloupcich do hashe $colsinfo (zarovnani, viditelnost a podobne)
   my $colsinfo=$pkg->colsinfo($tableI);
   # hlavicka a telo tabulky
   my ($rowsI)=$tableI->findnodes('rows');
   $pkg->append_rowslist($tableO,$tableI,$rowsI,$colsinfo);
}
#== funkce renderujici znacku rows ==#
sub append_rowslist {
   my ($pkg_p, $tableOO,$tableI,$rowsI,$colsinfo)=@_;
   my $ulO;
   my $open;
   if($rowsI->findvalue('@open') ne "1" and $rowsI->findvalue('@open') ne "2" and $ENV{HTTP_USER_AGENT}=~/MSIE/) {
      $open=0;
   }
   else {
      $open=1;
   }
   if($rowsI->parentNode->nodeName ne "table" and !$open) {
      $ulO=$tableOO->aT("ul",{ class => "folderItemsHidden" });
   }
   else {
      $ulO=$tableOO->aT("ul",{ class => "folderItemsShow" });
   }
   foreach my $node ($rowsI->childNodes) {
      my $nodename=$node->cloneNode(0)->nodeName;
      if($nodename eq "row") {
         $pkg->append_rowlist($ulO,$node,$colsinfo);
      }
      elsif($nodename eq "rows") {
         $pkg->append_rowslist($ulO,$tableI,$node,$colsinfo);
      }
   }
}
#== funkce renderujici znacku row ==#
sub append_rowlist {
   my ($pkg_p, $tableOO,$row,$colsinfo)=@_;
   my $trO;
   my $nodeSibling=$row->nextSibling;
   if($nodeSibling and $nodeSibling->nodeName eq "rows") {
      my $liclass;
      if($nodeSibling->findvalue('@open') ne "1" and $nodeSibling->findvalue('@open') ne "2" and $ENV{HTTP_USER_AGENT}=~/MSIE/) {
         $liclass="folderClose";
      }
      elsif($nodeSibling->findvalue('@open') eq "2") {
         $liclass="folderTop";
      }
      else {
         $liclass="folderOpen";
      }
      $trO=$tableOO->aT("li",{ class => $liclass });
   }
   else {
      $trO=$tableOO->aT("li",{ class => "item" });
   }
   if(my $style=$row->findvalue('@style')) {
      $trO->setAttribute("style",$style); # !!! normalne uzivam pro nastaveni atributu fci sA (z MyXML), ktera prekodovava cestinu tady ne - asi NESMIM, jelikoz zde je hodnota tusim jiz v Unicode a neni ji tedy vubec mozne prekodovavat znovu !!!
   }
   my $colnum=0;
   foreach my $colI ($row->findnodes('col')) {
      if(!$$colsinfo{hidden}[$colnum]) {
         my $tdO=$trO->aT(undef,{}," ");
         $pkg->append_collist($tdO,$colI,$colsinfo,$colnum);
      }
      ++$colnum;
   }
}
#== funkce tisknouci hodnotu ci cely xhtml strom zadaneho node ==#
sub append_collist {
   my ($pkg_p, $nodeO,$nodeI,$colsinfo,$colnum)=@_;
   my ($value,$xhtml);
   ($value,$xhtml)=$pkg->return_value($nodeI);
   my $collength=length($value);
   # pripadne naformatovani hodnoty
   if(length($$colsinfo{formatfce}[$colnum]) and $collength) {
      my $format_fce=$$colsinfo{formatfce}[$colnum];
      $value=Format->$format_fce($value,@{$$colsinfo{formatfce_param}[$colnum]});
      # predpokladam, ze vsechny mezery se maji u formatovanych hodnot nahradit tvdyma
      ## ZATIM TO NEDELAM
      # Radek nize pozdeji odpoznamkovat ci jinak vyresit
      #$value=~s/ /\x{a0}/g;  # mozna to bude pozdeji treba zmenit (jde o tvrdou mezeru &#160; viz: http://www.perldoc.com/perl5.6/pod/perlunicode.html)
      # - konec
   }
   else {
      if(!$collength) {
         $value="\x{a0}"; # mozna to bude pozdeji treba zmenit (jde o tvrdou mezeru &#160; viz: http://www.perldoc.com/perl5.6/pod/perlunicode.html)
      }
   }
   $pkg->append_value($nodeO,$nodeI,$value,$xhtml);
}



#********** POMOCNE *********************************
#- tisk 
sub append_value {
   my ($pkg_p, $nodeO,$nodeI,$value,$xhtml)=@_;
   # neni ukecane, ale je to efektivni?
   if(my $onclick=$nodeI->findvalue('@onclick')) {
      $nodeO=aTtx($nodeO,"span",{onclick=>$onclick});
   }
   # ZMENA 2003-01-20 - $spanname zabranuje zbytecnemu mnozeni znacek
   my $spanname="span";
   if(my $href=$nodeI->findvalue('@href')) {
      $nodeO=$nodeO->aT("a",{href=>$href});
      $spanname=undef;
   }
   if(my $class=$nodeI->findvalue('@class')) {
      $nodeO=aTtx($nodeO,$spanname,{class=>$class});
      $spanname=undef;
   }
   if(my $style=$nodeI->findvalue('@style')) {
      $nodeO=aTtx($nodeO,$spanname,{style=>$style});
      $spanname=undef;
   }
   if(my $title=$nodeI->findvalue('@title')) {
      $nodeO=aTtx($nodeO,$spanname,{title=>$title});
      $spanname=undef;
   }
   # pridani hodnoty do dokumentu
   if($xhtml) {
      $nodeO->aNchilds($xhtml);
   }
   else {
      $nodeO->aT(undef,{},$value);
   }
   return $nodeO;
}


#=== funkce vraci hodnotu z node - repektuje ruzne vystupy a i pripadnou xhtml vetev
sub return_value {
   my ($pkg_p, $nodeI,$alwaysxhtml)=@_;
   my ($value,$xhtml);
   if(($xhtml)=$nodeI->findnodes('xhtml')) {
      # Poznamka: k pripadu, kdy v xhtml kodu bude na zacatku znacka "img" se budu chovat u vystupu ne "table" tak, ze nikdy nevratim xhtml kod, ale obsah atributu "alt" a to i v pripadech, kdy parametr $alwaysxhtml bude 1
      if((!$alwaysxhtml or $xhtml->findnodes('img')) and $$outputstyle{typvystupu} ne "table") {
         if(my ($img)=$xhtml->findnodes('img')) {
            $value=$img->findvalue('@alt');
         }
         else {
            $value=$xhtml->findvalue('.');
         }
         $xhtml=undef;
      }
   }
   else {
      $value=$nodeI->findvalue('.');
   }
   return ($value,$xhtml);
}


#== specialni funkce vkladajici znacky ==#
#- fce vklada znacky jen u vystupu "table"
sub aTt {
   my ($tagp,$tagname,$attr,$textval)=@_;
   my $tag;
   if($$outputstyle{typvystupu} eq "table") {
      $tag=$tagp->aT($tagname,$attr,$textval);
   }
   else {
      $tag=$tagp;
   }
   return $tag;
}

#- fce vklada znacky jen u vystupu "txt" nebo "txtfixed" a nektere i meni (span)
sub aTx {
   my ($tagp,$tagname,$attr,$textval)=@_;
   my $tag;
   if($$outputstyle{typvystupu} ne "table") {
      $tag=$tagp->aT($tagname,$attr,$textval);
   }
   else {
      $tag=$tagp;
   }
   return $tag;
}

#- fce vklada znacky jen u vystupu "txtfixed"
sub aTf {
   my ($tagp,$tagname,$attr,$textval)=@_;
   my $tag;
   if($$outputstyle{typvystupu} eq "txtfixed") {
      $tag=$tagp->aT($tagname,$attr,$textval);
   }
   else {
      $tag=$tagp;
   }
   return $tag;
}

#- fce vklada znacky u vsech vystupu, ale dle druhu jeste muze provest nejakou konverzi znacky
sub aTtx {
   my ($tagp,$tagname,$attr,$textval)=@_;
   my $tag;
   # kazda znacka obsahujici atribut style s hodnotou color: xxx bude jeste doplnena o znacku font s atributem color (to umi i links)
   my $color;
   if(($color=$$attr{style}) and ($color=~s/^.*color: *([^ ;]+).*/$1/g)) {
      $tag=$tagp->aT($tagname,$attr);
      $tag=$tag->aT("font",{color=>$color},$textval);
   }
   else {
      $tag=$tagp->aT($tagname,$attr,$textval);
   }
   return $tag;
}

#== pomocne funkce ==#
# fce cerpa nektere udaje o sloupcich do hashe $colsinfo, aby byly rychleji k dosazeni (zarovnani, viditelnost a podobne)
sub colsinfo {
   my ($pkg_p, $tableI)=@_;
   my $colsinfo;
   my $colnum=0;
   my $colfirst=1;
   foreach my $colI ($tableI->findnodes('cols/col')) {
      #- nacerpani nekterych informaci o sloupcich do hashe, pro jejich rychlejsi pozdejsi ziskani
      $$colsinfo{type}[$colnum]=$colI->findvalue('@type');
      $$colsinfo{hidden}[$colnum]=$colI->findvalue('@hidden');
      $$colsinfo{alignzn}[$colnum]=$pkg->colalign($colI->findvalue('@type'),1);
      # zjisteni cim u txtfixed metody oddelovat sloupce - nenili definovano volim dve mezery
      my $colsepar=$colI->findvalue('@colsepar');
      if($colsepar) {
         $$colsinfo{colsepar}[$colnum]=$colsepar;
      }
      elsif(!$colfirst) {
         $$colsinfo{colsepar}[$colnum]="  ";
      }
      else {
         $$colsinfo{colsepar}[$colnum]="";
      }
      # u txtfixed metody je mozne zalomit za sloupcem na vyzadani pokud existuje a je atribut colbreak 1
      $$colsinfo{colbreak}[$colnum]=$colI->findvalue('@colbreak');
      if($$outputstyle{formatovat}) {
         if(my $formatfce=$colI->findvalue('@formatfce')) {
            $$colsinfo{formatfce}[$colnum]=$formatfce;
         }
         elsif($colI->findvalue('@type') eq "number" and my $format=$colI->findvalue('@format')) {
            if(my ($prefix,$thous,$dec,$postfix)=Format->formatNumber_covert($format)) {
               if($$outputstyle{formatovat}==2) { # $$outputstyle{formatovat}==2 znamena neoddelovat tisice
                  $thous=0;
               }
               $$colsinfo{formatfce_param}[$colnum]=[$prefix,$thous,$dec,$postfix];
               $$colsinfo{formatfce}[$colnum]="formatNumber";
            }
         }
         elsif(($colI->findvalue('@type') eq "date" or $colI->findvalue('@type') eq "dateTime") and my $format=$colI->findvalue('@format')) {
            if(my $formatnew=Format->formatDate_covert($format)) {
               $$colsinfo{formatfce_param}[$colnum]=[$formatnew];
               $$colsinfo{formatfce}[$colnum]="formatDate";
            }
         }
      }
      if(!$$colsinfo{hidden}[$colnum]) {
         $colfirst=0;
      }
      ++$colnum;
   }
   # zaznamenani poctu sloupcu
   $$colsinfo{colcount}=$colnum;
   return $colsinfo;
}

## tahle funkce se mi nelibi - chtela by vylepsit a promerit efektivnost
#- funkce dolpnujici do colsinfo udaje o maximalni delce sloupcu a formatujici sloupce
sub collength {
   my ($pkg_p, $tableI,$colsinfo)=@_;
   # urceni maximalni sirky sloupcu
   foreach my $isvalue (0,1) {
      my @rowI;
      if(!$isvalue) {
         @rowI=$tableI->findnodes('cols');
      }
      else {
         @rowI=$tableI->findnodes('(rows//row|rows//rows_summary)');
      }
      foreach my $rowI (@rowI) {
         my $colnum=0;
         foreach my $colI ($rowI->findnodes('col')) {
            my ($value,$xhtml)=$pkg->return_value($colI);
            # pripadne naformatovani hodnoty - jen u pripadu tisku hodnot
            if($isvalue and length($$colsinfo{formatfce}[$colnum]) and length($value)) {
               my $format_fce=$$colsinfo{formatfce}[$colnum];
               $value=Format->$format_fce($value,@{$$colsinfo{formatfce_param}[$colnum]});
            }
            # zapis hodnoty (pripadne naformatovane) - abych zbytecne neformatoval pozdeji
            $colI->setAttribute("formatval",$value); # !!! normalne uzivam pro nastaveni atributu fci sA (z MyXML), ktera prekodovava cestinu tady po findnodes to nejde jelikoz vysledne tagy se netvari ze jsou z MyXML a asi je to i nemozne, jelikoz zde je hodnota tusim jiz v Unicode a neni ji tedy vubec mozne prekodovavat znovu !!!
            # zjisteni sirky sloupce
            my $collength=length($value);
            if($collength>$$colsinfo{collength}[$colnum]) {
               $$colsinfo{collength}[$colnum]=$collength;
            }
            ++$colnum;
         }
      }
   }
   # zjisteni kde pripadne zalamovat radek u vystupu txtfixed
   my @linesplitcolnum;
   my $singleline;
   my $colbreak;
   for(my $colnum=0;$colnum<$$colsinfo{colcount};++$colnum) {
      if(!$$colsinfo{hidden}[$colnum]) {
         my $colseparlen=length($$colsinfo{colsepar}[$colnum]);
         if(($singleline+$colseparlen+$$colsinfo{collength}[$colnum]>$$outputstyle{sloupcu}) or $colbreak) {
            $$colsinfo{linesplitspace}[$linesplitcolnum[-1]]=$pkg->linesplitspace(\@linesplitcolnum,$singleline);
            $singleline=0;
            $$colsinfo{linesplitspace}[$colnum]=0;
            $$colsinfo{colsepar}[$colnum]=""; $colseparlen=0;
            push(@linesplitcolnum,$colnum);
         }
         $singleline+=$colseparlen+$$colsinfo{collength}[$colnum];
         $colbreak=$$colsinfo{colbreak}[$colnum];
      }
   }
   $$colsinfo{linesplitspace}[$linesplitcolnum[-1]]=$pkg->linesplitspace(\@linesplitcolnum,$singleline);
   # kdyz je jiz zalomeni hodne pridej jeste dalsi, at je mezi skupinami volny radek
   # POZNAMKA: kdyz to chces i u mene polamani, tak si to muzes vynutit v programu pomoci atributu colbreak="1" u posledniho sloupce
   # pozn: ($$colsinfo{colcount}-1) - index posledniho sloupce; ($$colsinfo{colcount}) - o jednicku vetsi nez index posledniho sloupce
   if(@linesplitcolnum>=3 or $$colsinfo{colbreak}[$$colsinfo{colcount}-1]) {
      $$colsinfo{linesplitspace}[$$colsinfo{colcount}]=0;
      push(@linesplitcolnum,($$colsinfo{colcount}));
   }
   # zaznamenani poctu zalomeni
   $$colsinfo{linesplitcount}=@linesplitcolnum;
   return $colsinfo;
}

#- funkce zjistujici, zda se ma sloupec zarovnavat vlevo ci v pravo
sub colalign {
   my ($pkg_p, $type,$zn)=@_;
   my $colalign;
   if($type eq "number" or $type eq "date" or $type eq "time" or $type eq "dateTime") {
      if($zn) {
         $colalign="";
      }
      else {
         $colalign="right";
      }
   }
   else {
      if($zn) {
         $colalign="-";
      }
      else {
         $colalign="left";
      }
   }
   return $colalign;
}
sub colclass {
   my ($pkg_p,$chosen)=@_;
   if(!length($chosen)) {
      $chosen="0";
   }
   return "chosen" . $chosen;
}

#== pomocne funkce jen pro txtfixed vystup ==#
# pomocna funkce urcujici, pocet mezer pred zalomenym radkem
sub linesplitspace {
   my ($pkg_p, $linesplitcolnum_p,$singleline)=@_;
   my $linesplitspace=undef;
   if(defined($$linesplitcolnum_p[-1])) {
      if((my $space=$$outputstyle{sloupcu}-$singleline)>0) {
         $linesplitspace=$space;
      }
      else {
         $linesplitspace=0;
      }
   }
   return $linesplitspace;
}
# fce maze pripadny prazdny radek na konci $tag
sub dropemptyline {
   my ($pkg_p, $tag)=@_;
   my $emptyline=0;
   if($$outputstyle{dropemptyline} and $$outputstyle{typvystupu} eq "txtfixed") {
      while(my $lastchild=$tag->lastChild) {
         if($lastchild->nodeType==3) {
            my $lastchildvalue=$lastchild->nodeValue;
            if($lastchildvalue eq "\n") {
               $tag->removeChild($lastchild);
               $emptyline=1;
               last;
            }
            elsif($lastchildvalue=~/^ *$/) {
               $tag->removeChild($lastchild);
            }
            else {
               last;
            }
         }
         else {
            last;
         }
      }
   }
   return $emptyline;
}



#***********************************************
#== funkce doplnuje do HTML dokumentu informace o zadanych promenych tykajicich se vstupu
sub outputvar {
   my ($pkg_p, $bodyO,$vars,$outputdev)=@_;
   my $bodyOO;
   if($$outputdev{typvystupu} eq "txt" or $$outputdev{typvystupu} eq "txtfixed") {
      $bodyOO=$bodyO;
   }
   else {
      $bodyOO=$bodyO->aT("p");
   }
   my ($lineno,$colno);
   my $i=0;
   foreach my $var (@{$vars}) {
      my $doceO=XML::LibXML::Document->new;
      my $eO=MyXML->new("element");
      $doceO->setDocumentElement($eO);
      $eO->aT("i",{}, $$var[0] . " " );
      $eO->aT(undef,{}, $$var[1] );
      if($i<$#{$vars}) {
         $colno+=2;
         $eO->aT(undef,{}, ", " );
      }
      my $varlength=length($doceO->documentElement->findvalue("/element"));
      if($colno+$varlength>$$outputdev{sloupcu}) {
         $colno=$varlength;
         ++$lineno;
         $bodyOO->aT(undef,{},"\n");
      }
      else {
         $colno+=$varlength;
      }
      if(My->okruh_nazev=~/^Akt\./) {
         $bodyOO->aNchilds_nolink($eO);
      }
      else {
         $bodyOO->aNchilds($eO);
      }
      ++$i;
   }
   ++$lineno;
   #aTt($bodyOO,"br");
   $bodyOO->aT(undef,{},"\n");
   return $$outputdev{prvniradek}+$lineno;
}

#== funkce doplnuje do HTML dokumentu link na limit - dalsich X zaznamu
sub outputlimit {
   my ($pkg_p, $bodyO,$volby,$outputdev)=@_;
   my $idcs=$$volby{idcs};
   my @limit=@{$$volby{limit}};
   my $norow=$$volby{norow};
   if($norow>=$limit[1]) {
      my $tagO;
      ($$outputdev{prvniradek},$tagO)=$pkg->outputT($bodyO,"p",$outputdev);
      ($$outputdev{prvniradek})=$pkg->outputT($tagO,"a",{href=>Link->limit($idcs,@limit)},"Zobraz dalch ".$limit[1]." dk",$outputdev);
   }
   return $$outputdev{prvniradek};
}

#== Funkce vlozi znacku pre, pokud se jedna o vystup txtfixed, inac zadnou znacku nevklada
sub pre {
   my ($pkg_p, $tO,$outputdev)=@_;
   if($$outputdev{typvystupu} eq "txt" or $$outputdev{typvystupu} eq "txtfixed") {
      $tO=$tO->aT("pre");
   }
   return $tO;
}

#== Funkce vklada znacky, ale jen u vystupu table - u vystupu txt je casto nahrazuje
sub outputT {
   my ($pkg_p, $bodyO,$tagname,$attr,$textval,$outputdev)=@_;
   my $tag;
   my $zalomeni=1;
   if($$outputdev{typvystupu} eq "txt" or $$outputdev{typvystupu} eq "txtfixed") {
      if($tagname=~/^h.$/i) {
         $tag=$bodyO->aT(undef,{},"\n".$textval."\n");
         $zalomeni=2;
      }
      elsif($tagname=~/^a$/i) {
         $tag=$bodyO->aT($tagname,$attr,$textval);
         $zalomeni=0;
      }
      else {
         $tag=$bodyO->aT(undef,{},$textval."\n");
         $zalomeni=1;
      }
   }
   else {
      $tag=$bodyO->aT($tagname,$attr,$textval);
   }
   return ($$outputdev{prvniradek}+$zalomeni,$tag);
}

#== Funkce slouzici k odeslani XML dokumentu na vystupni zarizeni
sub outputprint {
   my ($pkg_p, $docO,$outputdev)=@_;
   # VYSTUP - do prohlizece
   if($$outputdev{typzar} eq "browser") {
      my $querybrow=new CGI({});
      print $querybrow->header(
               -type => $$outputdev{typzarspec},
               -charset => $$outputdev{cestina},
               -cookie => $$outputdev{cookie}
      );
      ## !!! pozor nize kritizovane instrukce jsou i v kodu jinde - v pripade jejich zmen se poohledni i jinde v teto knihovne !!!
      my $str_s=$docO->toStringHTML; # situace by se zjednodusila, kdyby nebyli vraceny opisy (html entities) ceskych znaku
      # konverze cestiny - konvertuje z HTML entit do prislusneho kodovani cestiny
      ## kdyz uz konvertujes MUSIS konvertovat vse az na &amp;&gt;&lt;&quot;
      ## lepsi by bylo nekonvertovat, ale podminkou pak je, aby links umel vsecky opisy HTML v nabizenych value hodnotach ve formularich a on dnes nektere neumi
      $str_s=Cs->cshtml2cs($str_s,$$outputdev{cestina}); # !!! zatim je fce pomala jelikoz vola externi program
      print $str_s;
   }
   # VYSTUP - jinam nez do prohlizece
   else {
      # nastav promenou obsahujici popis zarizeni na ktere bude probihat vystup vysledku tisku ci mailovou adresu
      my $querybrow=new CGI({});
      my $outputdevbrow=My->outputdev($querybrow);
      # vytvoreni html dokumentu
      my ($docObrow,$htmlObrow,$bodyObrow);
      ($docObrow,$htmlObrow,$bodyObrow,$$outputdevbrow{prvniradek})=MyXML->creahtml($outputdevbrow,$$outputdev{idcs});
      # nastaveni promene, ktera se muze nize pouzit
      my $filenameout="/tmp/output_".$$.".out";
      # VYSTUP - text/html mailem
      if($$outputdev{typzar} eq "mail" and $$outputdev{typvystupu} eq "table") {
         # uprava retezce a odeslani mailem
         my $str_s=$docO->toStringHTML;
         $str_s=Cs->cshtml2cs($str_s,$$outputdev{cestina});
         Outputsend->mail({
            From => $$outputdev{typzarspec},
            To => $$outputdev{typzarspec},
            Subject => 'Vystup z: '.Cs->cs2cs(My->okruh_nazev,"windows-1250","US-ASCII"),
            'Content-type' => 'text/html; charset="'.$$outputdev{cestina}.'"',
            Body => $str_s
         });
         # odeslani do prohlizece hlasku ze vysledek byl odelsan na prislusnou tiskarnu
         $bodyObrow->aT("p",{},"Vstup byl odesln na: " . $$outputdev{typzarspec});
         $pkg->outputprint($docObrow,$outputdevbrow);
      }
      # VYSTUP - text/html (lepe receno finalne PS) na tiskarnu
      elsif(($$outputdev{typzar} eq "printerux" or $$outputdev{typzar} eq "printerwin") and $$outputdev{typvystupu} eq "table") {
         # uprava retezce a tisk
         my $str_s=$docO->toStringHTML;
         $str_s=Cs->cshtml2cs($str_s,$$outputdev{cestina});
         ## ZMENA - bohuzel zatim nevim jak zajistit, aby ogonkify pri tisku nelikvidovalo znaky kulatych zavorek - proto je zde nyni nahrazuji hranatymi zavorkami
         $str_s=~s/\(/\[/g; $str_s=~s/\)/\]/g;
         my $filenamecss=My->www_path.'/share/templates/output.css';
         $ENV{HTML2PS_HTTP_USER}=My->remote_user;
         ## pouzite html2ps v /usr/local/bin je mnou specialne upraveno, aby pouzilo pro prihlaseni k webu promene prostredi HTML2PS_HTTP_USER a HTML2PS_HTTP_PASSWD
         open(FILE, '| /usr/local/bin/html2ps -f '.$filenamecss.' '.$$outputdev{inicializace}.' 2> /dev/null | ogonkify -M > '.$filenameout);
         print FILE $str_s;
         close(FILE);
         Outputsend->printer({
            printer => $$outputdev{typzarspec},
            platform => $$outputdev{typzar},
            file => $filenameout
         });
         unlink($filenameout);
         # odeslani do prohlizece hlasku ze vysledek byl odelsan na prislusnou tiskarnu
         $bodyObrow->aT("p",{},"Vstup byl odesln na: " . $$outputdev{typzarspec});
         $pkg->outputprint($docObrow,$outputdevbrow);
      }
      # VYSTUP - text/plain a na ruzna zarizeni
      else {
         my $str_s;
         my $substrod;
         if($$outputdev{plnyformat}) {
            $substrod=0;
            $str_s=$docO->documentElement->findvalue('/html/body/pre[@plnyformat=1]');
            # konverze cestiny
            $str_s=Cs->utf2cs($str_s,$$outputdev{cestina});
         }
         elsif($$outputdev{typvystupu} ne "table" and !$$outputdev{bezpre}) {
            $substrod=0;
            $str_s=$docO->documentElement->findvalue('/html/body');
            # konverze cestiny
            $str_s=Cs->utf2cs($str_s,$$outputdev{cestina});
         }
         else {
            $substrod=1;
            my $filename="/tmp/output_".$$.".html";
            open(FILE, ">".$filename);
            print FILE $docO->toStringHTML;
            close(FILE);
            # Poznamka 1: volam links z distribuce debianu (/usr/bin/links) jde vlastne o elinks (balicek links-ssl 0.96.20020409-2)
            # Poznamka 2: renderovani -dump pres links zatim likviduje cestinu, pozdeji snad pribude volba ve stylu "-dump-codepage" a problem vyresi...
            ##my $prikazlinks='links -dump -dump-width ' . $$outputdev{sloupcu} . ' ' . $filename;
            ## Nyni prechazim na elinks - ktery jsem normalne nakompiloval se zdrojaku a umoznuje mi vice voleb
            my $prikazlinks=q{/usr/local/bin/elinks -dump -no-home -eval 'set document.codepage.assume = "windows-1250"' -eval 'set document.dump.codepage = "windows-1250"' -eval 'set document.dump.width = } . $$outputdev{sloupcu} . q{'} . q{ } . $filename;
            $str_s=`$prikazlinks`;
            unlink($filename);
            # konverze cestiny
            $str_s=Cs->cs2cs($str_s,"windows-1250",$$outputdev{cestina});
         }
         # vytvoreni pracovniho souboru
         my $linebr;
         if($$outputdev{typzar} eq "mail") {
            $linebr="\x0A";
         }
         else {
            $linebr="\x0D\x0A";
         }
         open(FILE, ">".$filenameout);
         if($$outputdev{typzar} eq "printerux" or $$outputdev{typzar} eq "printerwin") {
            my $inicializace=$$outputdev{inicializace};
            $inicializace=~s/\\e/\e/g;
            $inicializace=~s/\\x{(..)}/chr(hex($1))/ge;
            print FILE $inicializace;
         }
         foreach my $line (split(/\n/,$str_s)) {
            print FILE " " x $$outputdev{lokraj};
            print FILE substr($line,$substrod,$$outputdev{sloupcu});
            print FILE $linebr;
         }
         if(!$$outputdev{plnyformat} and ($$outputdev{typzar} eq "printerux" or $$outputdev{typzar} eq "printerwin")) {
            print FILE $linebr;
            print FILE $linebr;
            print FILE "***** Konec *****";
            print FILE $linebr;
         }
         if($$outputdev{typzar} eq "printerux" or $$outputdev{typzar} eq "printerwin") {
            my $deinicializace=$$outputdev{deinicializace};
            $deinicializace=~s/\\e/\e/g;
            $deinicializace=~s/\\x{(..)}/chr(hex($1))/ge;
            print FILE $deinicializace;
         }
         close(FILE);
         if($$outputdev{typzar} eq "mail") {
            my $str_body;
            open(FILE,$filenameout);
            while(my $radek=<FILE>) {
               $str_body.=$radek;
            }
            close(FILE);
            Outputsend->mail({
               From => $$outputdev{typzarspec},
               To => $$outputdev{typzarspec},
               Subject => 'Vystup z: '.Cs->cs2cs(My->okruh_nazev,"windows-1250","US-ASCII"),
               'Content-type' => 'text/plain; charset="'.$$outputdev{cestina}.'"',
               Body => $str_body
            });
         }
         else {
            Outputsend->printer({
               printer => $$outputdev{typzarspec},
               platform => $$outputdev{typzar},
               file => $filenameout
            });
         }
         unlink($filenameout);
         # odeslani do prohlizece hlasku ze vysledek byl odelsan na prislusnou tiskarnu
         $bodyObrow->aT("p",{},"Vstup byl odesln na: " . $$outputdev{typzarspec});
         $pkg->outputprint($docObrow,$outputdevbrow);
      }
   }
}

#== Pomocna funkce pro stanoveni zobrazeni limitu v poctech zaznamu na vystup
sub deflimit {
   my ($pkg_p, $limit)=@_;
   my @limit;
   if(!defined($limit)) {
      @limit=(0,100);
   }
   else {
      @limit=split(/,/,$limit);
      $limit[0]*=1;
      $limit[1]*=1;
      if($limit[1]>4000) {
         $limit[1]=4000;
      }
   }
   return ($limit[0],$limit[1]);
}

#== Pomocna funkce slouzici k zobrazeni limitu v zobrazeni promennych
sub varlimit {
   my ($pkg_p, $norow,@limit)=@_;
   return ["Limit:",($limit[0]+1)."-".($limit[0]+$norow)];
}


return 1;

